#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,m,u,v;
    cin>>n>>m;
    vector<int> a(m),b(m),t(m);
    for(int i=0;i<m;i++)
        cin>>a[i]>>b[i]>>t[i];
    int br=0;
    cin>>u>>v;
    int tstaro=0;
    if(t[0]!=tstaro)
    {
        br++;
        tstaro=t[0];
    }
    for(int i=1;i<m;i++)
    {
        if(abs(a[i-1]-b[i-1])<abs(a[i]-b[i]) || a[i]==u )
        {
            if(a[i]>=u)
            {
                if(t[i]!=tstaro)
            {
                br++;
                tstaro=t[i];
            }
                u=b[i];
            }

            }
        if(u==v)
            cout<<br;
    }
    return 0;
}